#!/usr/bin/env python

import bootstrap
import Tkinter
import urllib2
import sys
import os

"""Attempt to fetch info from a running jcapture instance."""
def fetch_info( server ):
	try:
		stream = urllib2.urlopen( "http://" + server + "/jah/info" )
		result = { }
		for line in stream.readlines( ):
			split = line.rstrip( ).split( "=", 1 )
			result[ split[ 0 ] ] = split[ 1 ]
		return result
	except Exception, e:
		return { }

#
# All of these are silly, silly, silly
#

"""Provide controls for the ivtv jcapture server"""
class local_ivtv( Tkinter.Frame ):
	def __init__( self, master ):
		Tkinter.Frame.__init__( self, master )

		self.running = False
		self.server = "localhost"
		self.port = 51030
		self.uri = "/jah.mpg"
		self.secure = Tkinter.IntVar( )
		self.secure.set( 0 )
		self.title = "IVTV Capture"

		if self.valid( ):
			self.running = fetch_info( self.server + ":" + str( self.port ) ) != { }
			frame = Tkinter.Frame( master )
			frame.pack( fill = Tkinter.BOTH )
			Tkinter.Label( frame, text = self.title ).pack( side = Tkinter.TOP, fill = Tkinter.NONE, anchor = Tkinter.NW )
			self.b_play = Tkinter.Button( frame, text = "Play", command = self.play )
			self.b_play.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_stop = Tkinter.Button( frame, text = "Stop", command = self.stop )
			self.b_stop.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_start = Tkinter.Button( frame, text = "Start", command = self.start )
			self.b_start.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_secure = Tkinter.Checkbutton( frame, text = "Secure", variable = self.secure )
			self.b_secure.pack( side = Tkinter.LEFT )
			self.show_state( )

	def valid( self ):
		return os.path.exists( "/dev/video0" )

	def show_state( self ):
		if self.running:
			self.b_play.config( state = Tkinter.NORMAL )
			self.b_stop.config( state = Tkinter.NORMAL )
			self.b_start.config( state = Tkinter.DISABLED )
			self.b_secure.config( state = Tkinter.DISABLED )
		else:
			self.b_play.config( state = Tkinter.DISABLED )
			self.b_stop.config( state = Tkinter.DISABLED )
			self.b_start.config( state = Tkinter.NORMAL )
			self.b_secure.config( state = Tkinter.NORMAL )

	def start( self ):
		command = "jcapture --port=" + str( self.port ) + " --title=\"" + self.title + "\" --device=/dev/video0 --mime=video/mpeg --extension=ivtvextras --uri=" + self.uri
		if self.secure.get( ) == 1:
			command += " --host=" + self.server
		os.system( command )
		self.running = True
		self.show_state( )

	def stop( self ):
		try:
			self.running = False
			self.show_state( )
			urllib2.urlopen( "http://" + self.server + ":" + str( self.port ) + "/jah/quit" )
		except Exception, e:
			pass

	def play( self ):
		os.spawnvpe( os.P_NOWAIT, "jbatch_tk", [ "jbatch_tk", "oml:http://" + self.server + ":" + str( self.port ) + self.uri ], os.environ )

"""Provide controls for the dv jcapture server"""
class local_dv( Tkinter.Frame ):
	def __init__( self, master ):
		Tkinter.Frame.__init__( self, master )

		self.running = False
		self.server = "localhost"
		self.port = 51031
		self.uri = "/jah.dv"
		self.pal = Tkinter.IntVar( )
		self.pal.set( 1 )
		self.secure = Tkinter.IntVar( )
		self.secure.set( 0 )
		self.title = "DV Capture"

		if self.valid( ):
			self.running = fetch_info( self.server + ":" + str( self.port ) ) != { }
			frame = Tkinter.Frame( master )
			frame.pack( fill = Tkinter.BOTH )
			Tkinter.Label( frame, text = self.title ).pack( side = Tkinter.TOP, fill = Tkinter.NONE, anchor = Tkinter.NW )
			self.b_play = Tkinter.Button( frame, text = "Play", command = self.play )
			self.b_play.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_stop = Tkinter.Button( frame, text = "Stop", command = self.stop )
			self.b_stop.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_start = Tkinter.Button( frame, text = "Start", command = self.start )
			self.b_start.pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			self.b_secure = Tkinter.Checkbutton( frame, text = "Secure", variable = self.secure )
			self.b_secure.pack( side = Tkinter.LEFT )
			self.b_pal = Tkinter.Checkbutton( frame, text = "PAL", variable = self.pal )
			self.b_pal.pack( side = Tkinter.LEFT )
			self.show_state( )

	def valid( self ):
		return os.path.exists( "/dev/dv1394/0" )

	def show_state( self ):
		if self.running:
			self.b_play.config( state = Tkinter.NORMAL )
			self.b_stop.config( state = Tkinter.NORMAL )
			self.b_start.config( state = Tkinter.DISABLED )
			self.b_pal.config( state = Tkinter.DISABLED )
			self.b_secure.config( state = Tkinter.DISABLED )
		else:
			self.b_play.config( state = Tkinter.DISABLED )
			self.b_stop.config( state = Tkinter.DISABLED )
			self.b_start.config( state = Tkinter.NORMAL )
			self.b_pal.config( state = Tkinter.NORMAL )
			self.b_secure.config( state = Tkinter.NORMAL )

	def start( self ):
		command = "jcapture --port=" + str( self.port ) + " --title=\"" + self.title + "\" --device=/dev/dv1394/0 --mime=video/dv --count=100 --extension=dvextras --uri=" + self.uri
		if self.secure.get( ) == 1:
			command += " --host=" + self.server
		command += " --block=" + [ "120000", "144000" ][ self.pal.get( ) ]
		os.system( command )
		self.running = True
		self.show_state( )

	def stop( self ):
		try:
			self.running = False
			self.show_state( )
			urllib2.urlopen( "http://" + self.server + ":" + str( self.port ) + "/jah/quit" )
		except Exception, e:
			pass

	def play( self ):
		os.spawnvpe( os.P_NOWAIT, "jbatch_tk", [ "jbatch_tk", "oml:http://" + self.server + ":" + str( self.port ) + self.uri ], os.environ )

"""Provide basic access to a remote jcapture server"""
class remote( Tkinter.Frame ):
	def __init__( self, master, server ):
		Tkinter.Frame.__init__( self, master )
		self.server = server
		self.info = { }
		if self.server_exists( server ):
			frame = Tkinter.Frame( master )
			frame.pack( fill = Tkinter.BOTH )
			if "title" in self.info.keys( ):
				text = self.info[ "title" ]
				if "capture" in self.info.keys( ) and self.info[ "capture" ] != "":
					text += "\n" + "http://" + self.server + self.info[ "capture" ]
				Tkinter.Label( frame, text = text ).pack( side = Tkinter.TOP, fill = Tkinter.NONE, anchor = Tkinter.NW )
			else:
				Tkinter.Label( frame, text = self.server ).pack( side = Tkinter.TOP )
			if "capture" in self.info.keys( ) and self.info[ "capture" ] != "":
				Tkinter.Button( frame, text = "Play", command = self.play ).pack( side = Tkinter.RIGHT, anchor = Tkinter.E )
			if "browse" in self.info.keys( ) and self.info[ "browse" ] == "1":
				Tkinter.Button( frame, text = "Browse", command = self.browse ).pack( side = Tkinter.RIGHT, anchor = Tkinter.E )

	def server_exists( self, server ):
		self.info = fetch_info( server )
		return self.info != { }

	def valid( self ):
		return self.info != { }

	def play( self ):
		os.spawnvpe( os.P_NOWAIT, "jbatch_tk", [ "jbatch_tk", "oml:http://" + self.server + self.info[ "capture" ] ], os.environ )

	def browse( self ):
		os.spawnvpe( os.P_NOWAIT, "firefox", [ "firefox", "http://" + self.server ], os.environ )

"""The main app - checks for local and remote jcapture server availability and
presents some options for interacting with them"""

class App( Tkinter.Frame ):
	def __init__( self, master, ops ):
		Tkinter.Frame.__init__( self, master )
		self.master = master
		self.nodes = None

		container = Tkinter.Frame( master )
		container.pack( expand = False, anchor = Tkinter.W, fill = Tkinter.BOTH )

		frame = Tkinter.Frame( master )
		frame.pack( fill = Tkinter.BOTH )

		Tkinter.Label( frame, text = "Computer" ).pack( side = Tkinter.LEFT )
		self.server = Tkinter.StringVar( )
		self.server.set( "localhost" )
		if len( ops ) == 1:
			self.server.set( ops[ 0 ] )
		entry = Tkinter.Entry( frame, textvariable = self.server ).pack( side = Tkinter.LEFT, expand = True, fill = Tkinter.X )
		self.bprobe = Tkinter.Button( frame, text = "Probe", command = self.probe )
		self.bprobe.pack( side = Tkinter.LEFT )

		self.after( 100, self.probe )

	def probe( self ):
		if self.nodes is not None:
			self.nodes.destroy( )

		self.nodes = Tkinter.Frame( self.master )
		self.nodes.pack( fill = Tkinter.BOTH )

		self.bprobe.config( state = Tkinter.DISABLED )

		if self.server.get( ) == "localhost":
			for type in [ local_ivtv, local_dv ]:
				node = type( self.nodes )
				if node.valid( ):
					node.pack( side = Tkinter.LEFT )
				self.update( )
		else:
			for port in range( 51030, 51039 ):
				node = remote( self.nodes, "%s:%d" % ( self.server.get( ), port ) )
				if node.valid( ):
					node.pack( side = Tkinter.LEFT )
				self.update( )

		self.bprobe.config( state = Tkinter.NORMAL )

"""Basic usage message"""
def usage( ):
	print "jcapture_admin [ server ]"

"""Main entry point"""
def main( ):
	ops = [ ]

	for i in sys.argv[ 1: ]:
		arg = None

		if i.startswith( "--" ) and i.find( "=" ) > 0:
			i, arg = i.split( "=", 1 )

		if i in ( "--help" ):
			usage( )
			sys.exit( 0 )
		else:
			arg = i

		if arg is not None:
			ops.append( arg )

	root = Tkinter.Tk( )
	app = App( root, ops )
	root.mainloop( )

if __name__ == "__main__":
	main( )

