import os
import urllib
import openpluginlib

class jcap_extension:
	uris = { }
	uris[ "list" ] = "/jah/list"
	uris[ "play" ] = "/jah/play"
	uris[ "pause" ] = "/jah/pause"
	uris[ "rewind" ] = "/jah/rewind"
	uris[ "ffwd" ] = "/jah/ff"

	js = """
	<script type="text/javascript" language="JavaScript">  
		function fetch( uri )
		{
			var xmlhttp = null

			if ( window.XMLHttpRequest )
				xmlhttp = new XMLHttpRequest( )
			else if ( window.ActiveXObject )
				xmlhttp = new ActiveXObject( "Microsoft.XMLHTTP" )

			if (xmlhttp!=null)
			{
  				xmlhttp.open( "GET", uri, true )
  				xmlhttp.send( null )
			}
		}
	</script>"""

	transport = """
	<table>
		<tr>
			<td><form><input type="button" onClick="fetch('/jah/play')" value="Play"></form></td>
			<td><form><input type="button" onClick="fetch('/jah/pause')" value="Pause"></form></td>
			<td><form><input type="button" onClick="fetch('/jah/ff')" value="Ffwd"></form></td>
			<td><form><input type="button" onClick="fetch('/jah/rewind')" value="Rewind"></form></td>
		</tr>
	</table>"""

	def process( self, request ):
		path, name = os.path.split( request.split[ 0 ] )
		if name == "list":
			self.list( request )
		elif name == "play":
			self.play( request )
		elif name == "pause":
			self.pause( request )
		elif name == "rewind":
			self.rewind( request )
		elif name == "ff":
			self.ff( request )

	def is_media_extension( self, extension ):
		all_extensions = ""

		oil_plugins = openpluginlib.discovery( openpluginlib.all_query_traits( "openmedialib", "", "", 0 ) )
		for y in oil_plugins:
			all_extensions = all_extensions + y.in_filter( )

 		extension = extension.lower( )
 		return all_extensions.find( extension ) != -1

	def list( self, request ):
		dir = "/"
		if "dir" in request.args.keys( ):
			dir = request.args[ "dir" ]

		request.wfile.write( "HTTP/1.1 200 OK\r\n\r\n" )
		request.wfile.write( "<html>" )
		request.wfile.write( jcap_extension.js )
		request.wfile.write( "<body>" )
		request.wfile.write( "<h2>List for " + dir + "</h2>" )
		request.wfile.write( "<hr>" )
		request.wfile.write( jcap_extension.transport )
		request.wfile.write( "<ul>" )

		if dir != "/":
			parent = urllib.quote( os.path.split( dir )[ 0 ] )
			request.wfile.write( "<li><a href='/jah/list?dir=" + parent + "'>[ Parent ]</a><br>" )

		list = os.listdir( dir )
		list.sort( )

		for file in list:
			full = os.path.join( dir, file )
			if os.path.isdir( full ) and file[ 0 ] != '.':
				parent, child = os.path.split( full )
				request.wfile.write( "<li><a href='/jah/list?dir=" + urllib.quote( full ) + "'>" + child + "/</a><br>" )

		for file in list:
			full = os.path.join( dir, file )
			prefix, ext = os.path.splitext( file )
			if not os.path.isdir( full ) and file[ 0 ] != '.' and ext != "" and ( self.is_media_extension( ext ) or ext == ".oml" ):
				parent, child = os.path.split( full )
				request.wfile.write( "<li><a href='/jah/play?file=" + urllib.quote( full ) + "'>" + child + "</a><br>" )

		request.wfile.write( "</ul>" )
		request.wfile.write( "</body>" )
		request.wfile.write( "</html>" )

	def play( self, request ):
		file = None
		if "file" in request.args.keys( ):
			file = request.args[ "file" ]
		if file is not None:
			os.system( "jbatch_client stop purge \"" + file + "\" start" )
		else:
			os.system( "jbatch_client play" )
		request.wfile.write( "HTTP/1.1 204 No Content\r\n\r\n" )

	def pause( self, request ):
		os.system( "jbatch_client pause" )
		request.wfile.write( "HTTP/1.1 204 No Content\r\n\r\n" )

	def rewind( self, request ):
		os.system( "jbatch_client rew" )
		request.wfile.write( "HTTP/1.1 204 No Content\r\n\r\n" )

	def ff( self, request ):
		os.system( "jbatch_client ffwd" )
		request.wfile.write( "HTTP/1.1 204 No Content\r\n\r\n" )
